# A program drawing a grayscale pixel art image from the pixel values in a text file
# Created by Your Name, 2022-XX-XX
# make sure medialib.py is at the same folder as this file
## magic code #########################
from medialib import *
initialize() # always the first instruction of the program
#######################################

def read_pixels(filename):
    result = []
    with open(filename, "r", encoding="utf-8") as f:
        f.readline()
        size = [int(s) for s in f.readline().split()]
        #print(size)  # size of the image
        max_value = int(f.readline())
        for i in range(size[0]):
            row = f.readline().split() # a list of strings
            # scale the pixel values to 0~255
            result.append([int(p) * max_value / 255 for p in row])
    return result

# load the pixel values from the image file and assign to a 2-dimensional list
pixels = read_pixels("image.pgm")
#print(pixels)  # you can print the list to see the values

pixel_size = 6  # size of the rectangle, = w = h, you can change it

# Use nested for statements to loop through the list pixels
for ...:
    for ...:
        # Draw each pixel as a rectangle using rect(x, y, w, h, r, g, b) function
        # x and y should be calculated from the current index numbers
        # w = h = pixel_size
        # r = g = b = the current pixel value
        rect(...)

wait_mouse_leftclick()

# BONUS QUESTION:
# Draw the positive image reversed from the original image beside it

# Use nested for statements to loop through the list pixels
#for ...:
#    for...:
        # Think about how to convert each pixel value
        # from the negative image for its positive image.
        # The calculation of x and y is similar to the original image,
        # but you need to consider about a proper origin point to start drawing [0][0],
        # so that the positive image will not overlap the original image.
#        rect(...)

# wait_mouse_leftclick()

print("done")

all_done() # always the last instruction of the program
