# This program realizes a simulated user login interface.
# Note that this is definetly not a safe way of authentification.
# Created by Min LU, 2021-07-05, updated 2022-04-08
from medialib import *

initialize() # always the first instruction of the program

def draw_image(filename):
    clear()
    draw(filename, 200, 100, 400, 400)

lines = open("login.txt", "r", encoding="utf-8").readlines() # read all the lines from the text file
login_dict = {}
for line in lines:  # parse each line and store the username and password into a dictionary
    user = line.strip().split(':')
    username = user[0]
    password = user[1]
    login_dict[username] = password # the key is username and the value is password

logged_in = False

while not logged_in:  # loop until logged in (can use while True as well)
    draw_image("login.png")
    username = input("Username: ") # get username
    if username in login_dict.keys():
        # username exists
        draw_image("password.png")
        password = input("Password: ") # get password
        if login_dict[username] == password: # check the password
            # password is correct
            draw_image("welcome.png")
            print("Welcome!")
            logged_in = True # can break here if using while True
        else:
            # password is wrong
            draw_image("wrong_password.png")
            print("Password is incorrect!")
    else:
        # username does not exist
        draw_image("wrong_user.png")
        print("No such user!")
    wait_mouse_leftclick()

print("done")

all_done() # always the last instruction of the program
