# Final Exercise 1

from medialib import *
from statistics import median

initialize()

#from matplotlib import pyplot as plt  
# you can also draw the histogram with matplotlib, like in the medialib ex3

# load the image data and draw pixels
""" Hint:
with open("cat.ppm", "r") as f:
    f.readline() # 1st line (P3)
    n_col, n_row = f.readline().split() # 2nd line (200 150)
    max_pixel = int(f.readline()) # 3rd line (255)
    for ... # rows
        for ... # pixels in a row 
            ...
            rect(...)
            #rect_norefresh(...) # if runs on macOS
    #refresh() # if runs on macOS
"""
# when looping through all the pixels, the number of pixels in each range of red, green and blue can be calculated
# the pixel values of the grayscale image can also be calcuated
# can use gray = 0.299 * r + 0.587 * g + 0.114 * b (round the result to integer)


# draw histograms of red, green and blue
# can write a function to draw a histogram, as it can be reused many times
# note that they should have the same Y-axis (max value) for comparisons


# save the data of the gray scale to a .pgm file (text file), like:
"""
P2
200 150
255
7 7 7 8 ....
....
"""
""" Hint:
with open("cat_grayscale.pgm", "w") as f:
    f.write("P2\n") # write the 1st line (P2)
    f.write(str(ncol) + " " + str(nrow) + "\n") # write the 2nd line (200 150)
    f.write("255\n") # write the 3rd line (255)
    for ... # rows
        for ... # pixels in a row 
"""

# load and display the saved .pgm file

# draw histograms of red, green and blue (they should have the same shape)

# apply median filter to the grayscale image
""" Hint:
# initialize a 2-D list for the pixels for the new image
# and fill in all the values as 255 (white)
pixels_filtered = [[255 for j in range(n_col)] for i in range(n_row)]
# loop through the pixels of the original grayscale image
# and get the median value of the 9 pixels around the current pixel
# but skip the first/last row/column
for i in range(1, ...):
    for j in range(1, ...):
        pixels_filtered = median([pixels_grayscale[i-1][j-1], [pixels_grayscale[i-1][j], ...])
"""

# save the filtered image to another .pgm file

# load and display the saved .pgm file of the filtered image

# draw histograms of red, green and blue (they should have the same shape)

wait_mouse_leftclick()

all_done()
